<template>
  <section notifications>
    <!-- <transition-group tag="div" name="snaccs"> -->
    <v-slide-y-transition>
      <v-snackbar
        v-if="latestSnacc"
        v-model="latestSnacc"
        bottom
        right
        :timeout="0"
        :key="latestSnacc.message"
        vertical
        :color="getType(latestSnacc)"
        @mouseenter="mouseOverSnacc"
        @mouseleave="mouseOutSnacc"
      >
        <transition name="timeout" appear @enter="startTimeout">
          <p
            v-if="latestSnacc.timeout"
            timeout-bar
            :style="timeoutBarStyle"
          ></p>
        </transition>
        <p>
          {{ latestSnacc.count > 1 ? "(x" + latestSnacc.count + ") " : ""
          }}{{ latestSnacc.message }}
        </p>

        <div actions>
          <v-btn
            v-for="action in latestSnacc.actions"
            :key="action"
            text
            @click="handleActionClick(action)"
            >{{ action }}</v-btn
          >
        </div>
      </v-snackbar>
    </v-slide-y-transition>
    <!-- </transition-group> -->
  </section>
</template>

<style lang="scss" scoped>
[actions] {
  display: flex;
  justify-content: flex-end;
}
[timeout-bar] {
  height: 5px;
  background: #00000066;
  margin: 0;

  position: absolute;
  top: 0;
  left: 0;
  right: 0;

  transition-property: right;
  transition-timing-function: linear;
}

.v-snack {
  ::v-deep .v-snack__wrapper {
    position: relative;
  }
}
</style>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import { Alert, AlertType } from "../store/modules/notifications";

@Component({
  components: {},
})
export default class extends Vue {
  // eslint-disable-next-line @typescript-eslint/no-empty-function
  private latestSnaccTimer = setTimeout(() => {}, 0);

  private timeoutBarStyle = {
    transitionDuration: "",
    right: "",
  };

  get latestSnacc(): Alert {
    return this.$store.getters.latestNotification;
  }

  private handleActionClick(action?: string) {
    this.resetTimeout();
    this.latestSnacc.cbChain.forEach(cb => cb(action));
    this.$store.commit("popNotification");
  }

  private getType(alert: Alert) {
    if (alert) {
      return AlertType[alert.type];
    }
  }

  private startTimeout() {
    if (this.latestSnacc && this.latestSnacc.timeout) {
      this.resetTimeout();
      // ensure a render with resetTimeout() style is done before we update again
      setTimeout(() => {
        this.timeoutBarStyle = {
          transitionDuration: this.latestSnacc.timeout + "ms",
          right: "100%",
        };
      }, 0);

      this.latestSnaccTimer = setTimeout(
        this.handleActionClick,
        this.latestSnacc.timeout
      );
    }
  }

  private resetTimeout() {
    clearTimeout(this.latestSnaccTimer);
    if (this.latestSnacc && this.latestSnacc.timeout) {
      this.timeoutBarStyle = {
        transitionDuration: "",
        right: "",
      };
    }
  }

  private mouseOverSnacc() {
    this.resetTimeout();
  }

  private mouseOutSnacc() {
    this.startTimeout();
  }
}
</script>
